//+------------------------------------------------------------------+
//|                                                         iVAR.mq4 |
//|                                        (C)opyright  2008, Ilnur |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "(C)opyright  2008, Ilnur"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_width1 2
#property indicator_level1 0.5
#property indicator_levelcolor White

extern int Periods = 5;

double ibuffer[];
double MathLog2, PeriodsML2,nWindow;
int init()
{
   MathLog2=MathLog(2.0);
   PeriodsML2=Periods*MathLog2;
   nWindow = MathPow(2,Periods);
   SetIndexBuffer(0,ibuffer);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,MathPow(2,Periods));
   SetIndexLabel(0,"iVAR");
   IndicatorShortName("iVAR("+Periods+")");
   return(0);
}

int start()
{
   int i, j, k,  nTotal, nIntervalkj, ihigh, ilow, nInterval, nCountedBars = IndicatorCounted();
   double Delta, X, Y, Sx, Sy, Sxx, Sxy;

   nTotal = Bars-nWindow;
   if(nCountedBars>nWindow) nTotal = Bars-nCountedBars-1;

   for(j=nTotal; j>=0; j--)
   {
      Sx = 0; Sy = 0; Sxx = 0; Sxy = 0;
      for(i=0; i<=Periods; i++)
      {
         nInterval = MathPow(2,Periods-i);
         for(Delta=0, k=0; k<MathPow(2,i); k++)
         {
            nIntervalkj=nInterval*k+j;
         	ihigh = iHighest(Symbol(),0,MODE_HIGH,nInterval,nIntervalkj);
         	ilow = iLowest(Symbol(),0,MODE_LOW,nInterval,nIntervalkj);
         	Delta += High[ihigh]-Low[ilow];
         }
         X = PeriodsML2-i*MathLog2;
         Y = MathLog(Delta);
         Sx += X; 
         Sy += Y;
         Sxx += X*X; 
         Sxy += X*Y;
      }
      ibuffer[j] = -(Sx*Sy-(Periods+1)*Sxy)/(Sx*Sx-(Periods+1)*Sxx);
   }
   return(0);
}